diff --git a/gcc/tree-vect-data-refs.c b/gcc/tree-vect-data-refs.c
index 9aabcc1..ad924d8 100644
--- a/gcc/tree-vect-data-refs.c
+++ b/gcc/tree-vect-data-refs.c
@@ -3353,8 +3353,8 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
   unsigned int i;
   tree length_factor;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
                      "=== vect_prune_runtime_alias_test_list ===\n");
 
   /* Step values are irrelevant for aliasing if the number of vector
@@ -3401,9 +3401,9 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
 	  vec_object_pair new_pair (DDR_OBJECT_A (ddr), DDR_OBJECT_B (ddr));
 	  if (!compared_objects.add (new_pair))
 	    {
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_NOTE, vect_location, "checking that ");
+		  vect_location_writeln (OPT_RECORD_REMARK, "checking that ");
 		  dump_generic_expr (MSG_NOTE, TDF_SLIM, new_pair.first);
 		  dump_printf (MSG_NOTE, " and ");
 		  dump_generic_expr (MSG_NOTE, TDF_SLIM, new_pair.second);
@@ -3426,9 +3426,9 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
 	  && (vect_preserves_scalar_order_p (stmt_a, stmt_b)
 	      || vectorizable_with_step_bound_p (dr_a, dr_b, &lower_bound)))
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location,
+	      vect_location_writeln (OPT_RECORD_REMARK,
 			       "no need for alias check between ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dr_a));
 	      dump_printf (MSG_NOTE, " and ");
@@ -3449,9 +3449,9 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
 	      || vect_small_gap_p (loop_vinfo, dr_b, lower_bound)))
 	{
 	  bool unsigned_p = dr_known_forward_stride_p (dr_a);
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location, "no alias between ");
+	      vect_location_writeln (OPT_RECORD_REMARK, "no alias between ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dr_a));
 	      dump_printf (MSG_NOTE, " and ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dr_b));
@@ -3525,9 +3525,9 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
 					     segment_length_b,
 					     access_size_a,
 					     access_size_b);
-	  if (res >= 0 && dump_enabled_p ())
+	  if (res >= 0 && thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location,
+	      vect_location_writeln (OPT_RECORD_REMARK,
 			       "can tell at compile time that ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dr_a));
 	      dump_printf (MSG_NOTE, " and ");
@@ -3543,8 +3543,8 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
 
 	  if (res == 1)
 	    {
-	      if (dump_enabled_p ())
-		dump_printf_loc (MSG_NOTE, vect_location,
+	      if (thing_enabled_p ())
+		vect_location_writeln (OPT_RECORD_REMARK,
 				 "not vectorized: compilation time alias.\n");
 	      return false;
 	    }
@@ -3566,13 +3566,13 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
   unsigned int count = (comp_alias_ddrs.length ()
 			+ check_unequal_addrs.length ());
 
-  dump_printf_loc (MSG_NOTE, vect_location,
+  vect_location_writeln (OPT_RECORD_REMARK,
 		   "improved number of alias checks from %d to %d\n",
 		   may_alias_ddrs.length (), count);
   if ((int) count > PARAM_VALUE (PARAM_VECT_MAX_VERSION_FOR_ALIAS_CHECKS))
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 			 "number of versioning for alias "
 			 "run-time tests exceeds %d "
 			 "(--param vect-max-version-for-alias-checks)\n",
@@ -3951,8 +3951,8 @@ vect_analyze_data_refs (vec_info *vinfo, poly_uint64 *min_vf)
   struct data_reference *dr;
   tree scalar_type;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
 		     "=== vect_analyze_data_refs ===\n");
 
   if (loop_vec_info loop_vinfo = dyn_cast <loop_vec_info> (vinfo))
@@ -3974,8 +3974,8 @@ vect_analyze_data_refs (vec_info *vinfo, poly_uint64 *min_vf)
 again:
       if (!dr || !DR_REF (dr))
         {
-          if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+          if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 	                     "not vectorized: unhandled data-ref\n");
           return false;
         }
@@ -4094,9 +4094,9 @@ again:
 
 	  if (gatherscatter == SG_NONE && !simd_lane_access)
 	    {
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		  vect_location_writeln (OPT_RECORD_FAILURE,
                                    "not vectorized: data ref analysis "
                                    "failed ");
 		  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
@@ -4111,8 +4111,8 @@ again:
 
       if (TREE_CODE (DR_BASE_ADDRESS (dr)) == INTEGER_CST)
         {
-          if (dump_enabled_p ())
-            dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+          if (thing_enabled_p ())
+            vect_location_writeln (OPT_RECORD_FAILURE,
                              "not vectorized: base addr of dr is a "
                              "constant\n");
 
@@ -4126,9 +4126,9 @@ again:
 
       if (TREE_THIS_VOLATILE (DR_REF (dr)))
         {
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
             {
-              dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+              vect_location_writeln (OPT_RECORD_FAILURE,
                                "not vectorized: volatile type ");
               dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
             }
@@ -4141,9 +4141,9 @@ again:
 
       if (stmt_can_throw_internal (stmt))
         {
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
             {
-              dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+              vect_location_writeln (OPT_RECORD_FAILURE,
                                "not vectorized: statement can throw an "
                                "exception ");
               dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
@@ -4160,9 +4160,9 @@ again:
       if (TREE_CODE (DR_REF (dr)) == COMPONENT_REF
 	  && DECL_BIT_FIELD (TREE_OPERAND (DR_REF (dr), 1)))
 	{
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
             {
-              dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+              vect_location_writeln (OPT_RECORD_FAILURE,
                                "not vectorized: statement is bitfield "
                                "access ");
               dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
@@ -4185,7 +4185,7 @@ again:
 	      || (gimple_call_internal_fn (stmt) != IFN_MASK_LOAD
 		  && gimple_call_internal_fn (stmt) != IFN_MASK_STORE)))
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
 	      dump_printf_loc (MSG_MISSED_OPTIMIZATION,  vect_location,
 	                       "not vectorized: dr in a call ");
@@ -4219,9 +4219,9 @@ again:
 	  tree init_addr = fold_build_pointer_plus (base, init_offset);
 	  tree init_ref = build_fold_indirect_ref (init_addr);
 
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location,
+	      vect_location_writeln (OPT_RECORD_REMARK,
                                "analyze in outer loop: ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, init_ref);
 	      dump_printf (MSG_NOTE, "\n");
@@ -4232,9 +4232,9 @@ again:
 	    /* dr_analyze_innermost already explained the failure.  */
 	    return false;
 
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location,
+	      vect_location_writeln (OPT_RECORD_REMARK,
                                "\touter base_address: ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM,
                                  STMT_VINFO_DR_BASE_ADDRESS (stmt_info));
@@ -4261,9 +4261,9 @@ again:
 
       if (STMT_VINFO_DATA_REF (stmt_info))
         {
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
             {
-              dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+              vect_location_writeln (OPT_RECORD_FAILURE,
                                "not vectorized: more than one data ref "
                                "in stmt: ");
               dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
@@ -4289,9 +4289,9 @@ again:
 	  && VAR_P (TREE_OPERAND (DR_BASE_ADDRESS (dr), 0))
 	  && DECL_NONALIASED (TREE_OPERAND (DR_BASE_ADDRESS (dr), 0)))
 	{
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
             {
-              dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+              vect_location_writeln (OPT_RECORD_FAILURE,
                                "not vectorized: base object not addressable "
 			       "for stmt: ");
               dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
@@ -4312,9 +4312,9 @@ again:
 	= get_vectype_for_scalar_type (scalar_type);
       if (!STMT_VINFO_VECTYPE (stmt_info))
         {
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
             {
-              dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+              vect_location_writeln (OPT_RECORD_FAILURE,
                                "not vectorized: no vectype for stmt: ");
               dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
               dump_printf (MSG_MISSED_OPTIMIZATION, " scalar_type: ");
@@ -4341,9 +4341,9 @@ again:
         }
       else
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location,
+	      vect_location_writeln (OPT_RECORD_REMARK,
 			       "got vectype for stmt: ");
 	      dump_gimple_stmt (MSG_NOTE, TDF_SLIM, stmt, 0);
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM,
@@ -4366,9 +4366,9 @@ again:
 	    {
 	      STMT_VINFO_DATA_REF (stmt_info) = NULL;
 	      free_data_ref (dr);
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		  vect_location_writeln (OPT_RECORD_FAILURE,
 				   (gatherscatter == GATHER) ?
 				   "not vectorized: not suitable for gather "
 				   "load " :
@@ -4389,9 +4389,9 @@ again:
 	{
 	  if (nested_in_vect_loop_p (loop, stmt))
 	    {
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location, 
+		  vect_location_writeln (OPT_RECORD_FAILURE,
                                    "not vectorized: not suitable for strided "
                                    "load ");
 		  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
@@ -4621,9 +4621,9 @@ vect_create_addr_base_for_vector_ref (gimple *stmt,
 	mark_ptr_info_alignment_unknown (SSA_NAME_PTR_INFO (addr_base));
     }
 
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location, "created ");
+      vect_location_writeln (OPT_RECORD_REMARK, "created ");
       dump_generic_expr (MSG_NOTE, TDF_SLIM, addr_base);
       dump_printf (MSG_NOTE, "\n");
     }
@@ -4748,10 +4748,10 @@ vect_create_data_ref_ptr (gimple *stmt, tree aggr_type, struct loop *at_loop,
      in LOOP.  */
   base_name = get_name (DR_BASE_ADDRESS (dr));
 
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
       tree dr_base_type = TREE_TYPE (DR_BASE_OBJECT (dr));
-      dump_printf_loc (MSG_NOTE, vect_location,
+      vect_location_writeln (OPT_RECORD_REMARK,
                        "create %s-pointer variable to type: ",
 		       get_tree_code_name (TREE_CODE (aggr_type)));
       dump_generic_expr (MSG_NOTE, TDF_SLIM, aggr_type);
@@ -5078,8 +5078,8 @@ vect_grouped_store_supported (tree vectype, unsigned HOST_WIDE_INT count)
      be a power of two.  */
   if (count != 3 && exact_log2 (count) == -1)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 			 "the size of the group of accesses"
 			 " is not a power of 2 or not eqaul to 3\n");
       return false;
@@ -5097,8 +5097,8 @@ vect_grouped_store_supported (tree vectype, unsigned HOST_WIDE_INT count)
 	  unsigned int nelt;
 	  if (!GET_MODE_NUNITS (mode).is_constant (&nelt))
 	    {
-	      if (dump_enabled_p ())
-		dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      if (thing_enabled_p ())
+		vect_location_writeln (OPT_RECORD_FAILURE,
 				 "cannot handle groups of 3 stores for"
 				 " variable-length vectors\n");
 	      return false;
@@ -5124,7 +5124,7 @@ vect_grouped_store_supported (tree vectype, unsigned HOST_WIDE_INT count)
 	      indices.new_vector (sel, 2, nelt);
 	      if (!can_vec_perm_const_p (mode, indices))
 		{
-		  if (dump_enabled_p ())
+		  if (thing_enabled_p ())
 		    dump_printf (MSG_MISSED_OPTIMIZATION,
 				 "permutation op not supported by target.\n");
 		  return false;
@@ -5142,7 +5142,7 @@ vect_grouped_store_supported (tree vectype, unsigned HOST_WIDE_INT count)
 	      indices.new_vector (sel, 2, nelt);
 	      if (!can_vec_perm_const_p (mode, indices))
 		{
-		  if (dump_enabled_p ())
+		  if (thing_enabled_p ())
 		    dump_printf (MSG_MISSED_OPTIMIZATION,
 				 "permutation op not supported by target.\n");
 		  return false;
@@ -5176,7 +5176,7 @@ vect_grouped_store_supported (tree vectype, unsigned HOST_WIDE_INT count)
 	}
     }
 
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     dump_printf (MSG_MISSED_OPTIMIZATION,
 		 "permutaion op not supported by target.\n");
   return false;
@@ -5689,8 +5689,8 @@ vect_grouped_load_supported (tree vectype, bool single_element_p,
      see PR65518).  */
   if (single_element_p && maybe_gt (count, TYPE_VECTOR_SUBPARTS (vectype)))
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 			 "single-element interleaving not supported "
 			 "for not adjacent vector loads\n");
       return false;
@@ -5700,8 +5700,8 @@ vect_grouped_load_supported (tree vectype, bool single_element_p,
      be a power of two.  */
   if (count != 3 && exact_log2 (count) == -1)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 			 "the size of the group of accesses"
 			 " is not a power of 2 or not equal to 3\n");
       return false;
@@ -5716,8 +5716,8 @@ vect_grouped_load_supported (tree vectype, bool single_element_p,
 	  unsigned int nelt;
 	  if (!GET_MODE_NUNITS (mode).is_constant (&nelt))
 	    {
-	      if (dump_enabled_p ())
-		dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      if (thing_enabled_p ())
+		vect_location_writeln (OPT_RECORD_FAILURE,
 				 "cannot handle groups of 3 loads for"
 				 " variable-length vectors\n");
 	      return false;
@@ -5737,8 +5737,8 @@ vect_grouped_load_supported (tree vectype, bool single_element_p,
 	      indices.new_vector (sel, 2, nelt);
 	      if (!can_vec_perm_const_p (mode, indices))
 		{
-		  if (dump_enabled_p ())
-		    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		  if (thing_enabled_p ())
+		    vect_location_writeln (OPT_RECORD_FAILURE,
 				     "shuffle of 3 loads is not supported by"
 				     " target\n");
 		  return false;
@@ -5751,8 +5751,8 @@ vect_grouped_load_supported (tree vectype, bool single_element_p,
 	      indices.new_vector (sel, 2, nelt);
 	      if (!can_vec_perm_const_p (mode, indices))
 		{
-		  if (dump_enabled_p ())
-		    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		  if (thing_enabled_p ())
+		    vect_location_writeln (OPT_RECORD_FAILURE,
 				     "shuffle of 3 loads is not supported by"
 				     " target\n");
 		  return false;
@@ -5783,8 +5783,8 @@ vect_grouped_load_supported (tree vectype, bool single_element_p,
         }
     }
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_FAILURE,
 		     "extract even/odd not supported by target\n");
   return false;
 }
@@ -6126,8 +6126,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       vec_perm_indices indices (sel, 2, nelt);
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "shuffle of 2 fields structure is not \
 			      supported by target\n");
 	  return false;
@@ -6141,8 +6141,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       indices.new_vector (sel, 2, nelt);
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "shuffle of 2 fields structure is not \
 			      supported by target\n");
 	  return false;
@@ -6156,8 +6156,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       indices.new_vector (sel, 2, nelt);
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "shift permutation is not supported by target\n");
 	  return false;
 	}
@@ -6172,8 +6172,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       indices.new_vector (sel, 2, nelt);
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "select is not supported by target\n");
 	  return false;
 	}
@@ -6236,8 +6236,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       vec_perm_indices indices (sel, 2, nelt);
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "shuffle of 3 fields structure is not \
 			      supported by target\n");
 	  return false;
@@ -6251,8 +6251,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       indices.new_vector (sel, 2, nelt);
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "shift permutation is not supported by target\n");
 	  return false;
 	}
@@ -6265,8 +6265,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       indices.new_vector (sel, 2, nelt);
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "shift permutation is not supported by target\n");
 	  return false;
 	}
@@ -6279,8 +6279,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       indices.new_vector (sel, 2, nelt);
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "shift permutation is not supported by target\n");
 	  return false;
 	}
@@ -6293,8 +6293,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       indices.new_vector (sel, 2, nelt);
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "shift permutation is not supported by target\n");
 	  return false;
 	}
